package dev.shadowsoffire.apotheosis.ench;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.ench.Ench;
import dev.shadowsoffire.apotheosis.ench.anvil.AnvilTile;
import dev.shadowsoffire.apotheosis.ench.enchantments.NaturesBlessingEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.ReflectiveEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.SpearfishingEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.StableFootingEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.corrupted.BerserkersFuryEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.corrupted.LifeMendingEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.ChainsawEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.EarthsBoonEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.KnowledgeEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.masterwork.ScavengerEnchant;
import dev.shadowsoffire.apotheosis.ench.enchantments.twisted.MinersFervorEnchant;
import dev.shadowsoffire.apotheosis.ench.objects.ExtractionTomeItem;
import dev.shadowsoffire.apotheosis.ench.objects.ImprovedScrappingTomeItem;
import dev.shadowsoffire.apotheosis.ench.objects.ScrappingTomeItem;
import java.util.Map;
import java.util.stream.Collectors;
import net.minecraft.core.BlockPos;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.projectile.ThrownTrident;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.AnvilMenu;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Items;
import net.minecraft.world.item.enchantment.Enchantment;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraft.world.item.enchantment.Enchantments;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.Tags;
import net.minecraftforge.event.AnvilUpdateEvent;
import net.minecraftforge.event.entity.living.LivingDropsEvent;
import net.minecraftforge.event.entity.living.LivingHealEvent;
import net.minecraftforge.event.entity.living.LivingHurtEvent;
import net.minecraftforge.event.entity.living.LootingLevelEvent;
import net.minecraftforge.event.entity.living.ShieldBlockEvent;
import net.minecraftforge.event.entity.player.AnvilRepairEvent;
import net.minecraftforge.event.entity.player.PlayerEvent;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.level.BlockEvent;
import net.minecraftforge.eventbus.api.EventPriority;
import net.minecraftforge.eventbus.api.SubscribeEvent;

public class EnchModuleEvents {
  @SubscribeEvent
  public void anvilEvent(AnvilUpdateEvent e) {
    if (e.getLeft().m_41793_())
      if (e.getRight().m_41720_() == Items.f_41863_) {
        ItemStack stack = e.getLeft().m_41777_();
        EnchantmentHelper.m_44865_((Map)EnchantmentHelper.m_44831_(stack).entrySet().stream().filter(ent -> ((Enchantment)ent.getKey()).m_6589_()).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue)), stack);
        e.setCost(1);
        e.setMaterialCost(1);
        e.setOutput(stack);
      } else if (e.getRight().m_41720_() == Ench.Items.PRISMATIC_WEB.get()) {
        ItemStack stack = e.getLeft().m_41777_();
        EnchantmentHelper.m_44865_((Map)EnchantmentHelper.m_44831_(stack).entrySet().stream().filter(ent -> !((Enchantment)ent.getKey()).m_6589_()).collect(Collectors.toMap(Map.Entry::getKey, Map.Entry::getValue)), stack);
        e.setCost(30);
        e.setMaterialCost(1);
        e.setOutput(stack);
        return;
      }  
    if ((e.getLeft().m_41720_() == Items.f_42147_ || e.getLeft().m_41720_() == Items.f_42148_) && e.getRight().m_204117_(Tags.Items.STORAGE_BLOCKS_IRON)) {
      if (e.getLeft().m_41613_() != 1)
        return; 
      int dmg = (e.getLeft().m_41720_() == Items.f_42148_) ? 2 : 1;
      ItemStack out = new ItemStack((dmg == 1) ? (ItemLike)Items.f_42146_ : (ItemLike)Items.f_42147_);
      EnchantmentHelper.m_44865_(EnchantmentHelper.m_44831_(e.getLeft()), out);
      out.m_41764_(1);
      e.setOutput(out);
      e.setCost(5 + e.getLeft().getAllEnchantments().entrySet().stream().mapToInt(ent -> ((Integer)ent.getValue()).intValue() * (((Enchantment)ent.getKey()).m_44699_().ordinal() + 1)).sum());
      e.setMaterialCost(1);
      return;
    } 
    if (ScrappingTomeItem.updateAnvil(e))
      return; 
    if (ImprovedScrappingTomeItem.updateAnvil(e))
      return; 
    if (ExtractionTomeItem.updateAnvil(e))
      return; 
  }
  
  @SubscribeEvent
  public void repairEvent(AnvilRepairEvent e) {
    if (ExtractionTomeItem.updateRepair(e))
      return; 
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void drops(LivingDropsEvent e) throws Throwable {
    Entity entity = e.getSource().m_7639_();
    if (entity instanceof Player) {
      Player p = (Player)entity;
      ((ScavengerEnchant)Ench.Enchantments.SCAVENGER.get()).drops(p, e);
      ((SpearfishingEnchant)Ench.Enchantments.SPEARFISHING.get()).addFishes(e);
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOWEST)
  public void dropsLowest(LivingDropsEvent e) {
    Entity entity = e.getSource().m_7639_();
    if (entity instanceof Player) {
      Player p = (Player)entity;
      ((KnowledgeEnchant)Ench.Enchantments.KNOWLEDGE.get()).drops(p, e);
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void healing(LivingHealEvent e) {
    if (e.getEntity().m_6095_() == EntityType.f_20529_)
      return; 
    ((LifeMendingEnchant)Ench.Enchantments.LIFE_MENDING.get()).lifeMend(e);
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void block(ShieldBlockEvent e) {
    ((ReflectiveEnchant)Ench.Enchantments.REFLECTIVE.get()).reflect(e);
  }
  
  @SubscribeEvent
  public void looting(LootingLevelEvent e) {
    DamageSource src = e.getDamageSource();
    if (src != null) {
      Entity entity = src.m_7640_();
      if (entity instanceof ThrownTrident) {
        ThrownTrident trident = (ThrownTrident)entity;
        ItemStack triStack = ((TridentGetter)trident).getTridentItem();
        e.setLootingLevel(triStack.getEnchantmentLevel(Enchantments.f_44982_));
      } 
    } 
  }
  
  @SubscribeEvent
  public void breakSpeed(PlayerEvent.BreakSpeed e) {
    ((StableFootingEnchant)Ench.Enchantments.STABLE_FOOTING.get()).breakSpeed(e);
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void breakSpeedLow(PlayerEvent.BreakSpeed e) {
    ((MinersFervorEnchant)Ench.Enchantments.MINERS_FERVOR.get()).breakSpeed(e);
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void breakSpeed(BlockEvent.BreakEvent e) {
    ((EarthsBoonEnchant)Ench.Enchantments.EARTHS_BOON.get()).provideBenefits(e);
    ((ChainsawEnchant)Ench.Enchantments.CHAINSAW.get()).chainsaw(e);
  }
  
  @SubscribeEvent
  public void rightClick(PlayerInteractEvent.RightClickBlock e) {
    ((NaturesBlessingEnchant)Ench.Enchantments.NATURES_BLESSING.get()).rightClick(e);
  }
  
  @SubscribeEvent(priority = EventPriority.LOWEST)
  public void applyUnbreaking(AnvilRepairEvent e) {
    AbstractContainerMenu abstractContainerMenu = (e.getEntity()).f_36096_;
    if (abstractContainerMenu instanceof AnvilMenu) {
      AnvilMenu anvMenu = (AnvilMenu)abstractContainerMenu;
      anvMenu.f_39770_.m_39292_((level, pos) -> {
            BlockEntity patt6975$temp = level.m_7702_(pos);
            if (patt6975$temp instanceof AnvilTile) {
              AnvilTile anvil = (AnvilTile)patt6975$temp;
              e.setBreakChance(e.getBreakChance() / (anvil.getEnchantments().getInt(Enchantments.f_44986_) + 1));
            } 
          });
    } 
  }
  
  @SubscribeEvent(priority = EventPriority.LOW)
  public void livingHurt(LivingHurtEvent e) {
    ((BerserkersFuryEnchant)Ench.Enchantments.BERSERKERS_FURY.get()).livingHurt(e);
  }
}
